
#' @importFrom S4Vectors endoapply
.subset.LoomExperiment <- function(x, i, j, ...)
{
    if (!missing(i)) {
        if(all(i > 0))
            rowGraphs(x) <- endoapply(rowGraphs(x), function(y) loomSelectHits(y, i))
        else
            rowGraphs(x) <- endoapply(rowGraphs(x), function(y) loomDropHits(y, abs(i)))
    }
    if (!missing(j)) {
        if(all(j > 0))
            colGraphs(x) <- endoapply(colGraphs(x), function(y) loomSelectHits(y, j))
        else
            colGraphs(x) <- endoapply(colGraphs(x), function(y) loomDropHits(y, abs(j)))
    }
    callNextMethod()
}


.show.LoomExperiment <- function(object)
{
    scat <- function(fmt, vals=character(), exdent=2, ...)
    {
        vals <- ifelse(nzchar(vals), vals, "''")
        lbls <- paste(S4Vectors:::selectSome(vals), collapse=' ')
        txt <- sprintf(fmt, length(vals), lbls)
        cat(strwrap(txt, exdent=exdent, ...), sep='\n')
    }
    callNextMethod()
    if (length(object@rowGraphs) > 0)
        scat('rowGraphs(%d): %s\n', names(object@rowGraphs))
    else
        cat('rowGraphs(0): NULL\n')
    if (length(object@colGraphs) > 0)
        scat('colGraphs(%d): %s\n', names(object@colGraphs))
    else
        cat('colGraphs(0): NULL\n')
}
